package com.madeu.controller.web.webuserpushhistory;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.servlet.ModelAndView;

import com.madeu.constants.Constants;
import com.madeu.init.ManagerDraftAction;
import com.madeu.service.web.webloghistory.WebLogHistoryService;
import com.madeu.service.web.webuserpushhistory.WebUserPushHistoryService;
import com.madeu.util.HttpUtil;
import com.madeu.view.web.WebUserPushHistoryView;

import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import lombok.extern.slf4j.Slf4j;


@Slf4j
@Controller
public class WebUserPushHistoryController extends ManagerDraftAction{

	@Autowired
	private WebUserPushHistoryService webUserPushHistoryService;
	
	@Autowired
	private WebLogHistoryService webLogHistoryService;
	
	/**
	 * 고객 - 알림 리스트 조회 화면으로 이동.
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webuserpushhistory/selectListUserPushHistoryIntro.do")
	public String  selectListUserPushHistoryIntro(HttpSession session,HttpServletRequest request, HttpServletResponse response, Model model) {
		log.debug("WebUserPushHistoryController  selectListUserPushHistoryIntro START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();
		
		try{
			if(!webCheckLogin(session)){
				return "/web/login/logout";
			}
			else {
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webUserPushHistoryService.selectListUserPushHistoryIntro(paramMap);
				
				model.addAttribute("selectUseYn", map.get("selectUseYn"));
				model.addAttribute("insertUseYn", map.get("insertUseYn"));
				model.addAttribute("updateUseYn", map.get("updateUseYn"));
				model.addAttribute("deleteUseYn", map.get("deleteUseYn"));
				model.addAttribute("downloadUseYn", map.get("downloadUseYn"));
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return "/web/login/logout";
		}
		log.debug("WebUserPushHistoryController  selectListUserPushHistoryIntro END");
		return "/web/user/userPushHistorySelectList";
	}
	
	/**
	 * 고객 - 알림 리스트 조회
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webuserpushhistory/selectListUserPushHistory.do")
	public ModelAndView selectListUserPushHistory(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
		log.debug("WebUserPushHistoryController selectListUserPushHistory START");
		
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();
		
		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webUserPushHistoryService.selectListUserPushHistory(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("WebUserPushHistoryController selectListUserPushHistory END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}
	/**
	 * <b>고객 - 알림 리스트 정보 엑셀 다운로드 </b>
	 * 페이지 처리 없음 
	 * request: 
	 * response : msgCode, msgDesc
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webuserpushhistory/downloadUserPushHistoryExcel.do")
	public ModelAndView downloadUserPushHistoryExcel(HttpSession session, HttpServletRequest request, HttpServletResponse response, @RequestParam(value = "file", required = false) MultipartFile file, Model model) {
		log.debug("WebUserPushHistoryController downloadUserPushHistoryExcel START");
		
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		List<Map<String, Object>> selectListReport = new ArrayList<Map<String,Object>>();
		Map<String, Object> map = new HashMap<String,Object>();
		
		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				selectListReport = webUserPushHistoryService.selectListUserPushHistoryExcel(paramMap);
				map.put("selectListUserPushHistory", selectListReport);
				map.put("name", "userpushhistory");
			}
		}
		catch(Exception e){
			e.printStackTrace();
			return null;
		}
		log.debug("WebUserPushHistoryController downloadUserPushHistoryExcel END");
		return new ModelAndView(new WebUserPushHistoryView(),"map",map);
	}
}
